# Plugins

It is possible to extend the CLI functionality by building plugins.

## Installing plugins

Plugins can be installed by running `inc plugins:add <npm-package>`. NPM packages that follow the
format `@includable/cli-<name>` can be simply installed by using `<name>`, any other NPM packages can only
be installed if they contain `cli-`.

If you wish to publish a CLI plugin, please let us know, so that we can publish it in the
[`@includable`](https://www.npmjs.com/org/includable) organization on NPM.

## Plugin API

Includable CLI plugins are simple Node packages, which export a function (in their `main` file, specified
in `package.json`) with a single argument, which is an instance of a
[commander.js](https://github.com/tj/commander.js) program:

```
module.exports = function(includable) {
    includable
        .command('ping')
        .description('Get a pong')
        .action(function() {
            program.output.notice('pong');
        });
};
```

Also, the `includable` object has the following additional keys:

* `util`: [utilty class](https://github.com/includable/cli/blob/master/lib/util.js)
* `output`: [output class](https://github.com/includable/cli/blob/master/lib/output.js)
* `plugins`: [plugins class](https://github.com/includable/cli/blob/master/lib/util/Plugins.js)
* `module`: [module class](https://github.com/includable/cli/blob/master/lib/containers/Module.js)
* `request`: [HTTP request method](https://github.com/includable/cli/blob/master/lib/util.js?L12)
