/*
 * Copyright (c) 2018 Includable.
 * Created by Thomas Schoffelen.
 */

const API = require('../util/API')
const output = require('../output')
const open = require('opn')

function checkSession (sessionId, showToken) {
  API.get('/sessions/' + sessionId).then(function (response) {
    if (response && response.data && response.data.data && response.data.data.token) {
      API.setToken(response.data.data.token)
      output.success('Nice! You are now signed in.')
      if (showToken) {
        output.gray('INCLUDABLE_TOKEN=' + response.data.data.token)
      }
      process.exit()
    }
    setTimeout(function () {
      checkSession(sessionId, showToken)
    }, 2000)
  })
}

module.exports = function (options) {
  API.post('/sessions', {
    client: 'com.includable.cli'
  }).then(function (response) {
    const sessionId = response.data.data.id
    const url = 'https://dashboard.includable.com/authenticate/' + sessionId
    output.log('Opening ' + url)
    open(url)
    output.log('Waiting for the session to be authenticated...')
    checkSession(sessionId, options.token)
  })
}
