/*
 * Copyright (c) 2018 Includable.
 * Created by Thomas Schoffelen.
 */

'use strict'

const _ = require('lodash')

const ModuleManifest = {
  getDevOption: function (option) {
    if ('dev' in this && typeof this.dev === 'object' && option in this.dev) {
      return this.dev[option]
    }
    if (option === 'scripts' && option in this) {
      return this[option]
    }

    return null
  }
}

const createManifest = function (manifest) {
  return _.defaults(manifest, ModuleManifest)
}

module.exports = createManifest
