/*
 * Copyright (c) 2018 Includable.
 * Created by Thomas Schoffelen.
 */

'use strict'

const minimatch = require('minimatch')
const Module = require('../containers/Module')

const matchFile = function (options, path) {
  if (typeof options.paths === 'string') {
    options.paths = [options.paths]
  }

  for (var i in options.paths) {
    if (!options.paths.hasOwnProperty(i)) {
      continue
    }
    if (minimatch(path, options.paths[i])) {
      return true
    }
  }

  return false
}

let manifest
Module.getManifest(function (manifestObj) {
  manifest = manifestObj
})

module.exports = function (path) {
  let options = manifest.getDevOption('ignore')
  if (options && typeof options === 'string') {
    options = {paths: [options]}
  }
  if (options && typeof options === 'object' && !('paths' in options) && 'length' in options) {
    options = {paths: options}
  }

  if (!options || typeof options !== 'object' || !('paths' in options)) {
    return false
  }

  return matchFile(options, path)
}
